#!/bin/bash

DISTRO="Unknown"
INSTALLEDWINE=0
WINEVERSION=0
REALWINEVERSION=0
WINEPREFIX="/usr"
TEMP="/tmp"
PWD=""

if [ `whoami` != 'root' ]
then
    echo "Пожалуйста, запустите скрипт с правами суперпользователя."
    exit 1
fi


echo "Привет."
echo
echo "Данный скрипт установит в вашей системе специальную версию wine, необходимую для запуска игры World of Tanks."
echo "Какие действия выполнит скрипт:"
echo "1. Проверит вашу систему на наличие необходимых компонентов."
echo "2. УДАЛИТ установленную у вас версию wine."
echo "3. Определит, какая версия wine последняя."
echo "4. Скачает исходные коды этой версии, пропатчит их, скомпилирует и установит."
echo "5. Скачает winetricks и с его помощью установит d3dx9_36, vcrun2008, corefonts, msxml3, wininet и ie7, необходимые для запуска WoT."
echo "Затем вы сможете установить или скопировать World of Tanks и поиграть."
echo
echo "Повторю еще раз, установленная у вас версия wine БУДЕТ УДАЛЕНА."
echo "Если вы не хотите удалять wine, нажмите Ctrl+C и скрипт прекратит свою работу."
echo "Если вы все же хотите продолжить, нажмите Enter."
echo

read

### 

echo "Во-первых, давайте проверим, установлены ли у вас подходящие драйверы..."
echo

if [ `glxinfo | grep render | grep -i Mesa` ]
then
    echo "Похоже, что необходимые драйверы не установлены."
    echo "Скорее всего вы не сможете поиграть в WoT."
    echo "Пожалуйста, обратитесь в сообщество пользователей вашего дистрибутива, для установки драйвера с поддержкой аппаратного ускорения."
else
    echo "Похоже все в порядке. У вас установлены подходящие драйверы."    
fi
echo
sleep 5

###

#echo "BTW, do you have installed wine?"
#if [ `wine --version | grep wine-` ]
#then
#    INSTALLEDWINE=1
#    echo "Yes, you have."
#else
#    echo "Looks like you don't."
#fi

###

echo "Ok, теперь давайте определим, каким дистрибутивом вы пользуетесь."
echo "И одновременно удалим установленный у вас wine"
if [ -f /etc/slackware-version ]
then
    DISTRO="Slackware"
    removepkg wine
fi
if [ -f /etc/redhat-release ]
then
    DISTRO="RedHat"
    rpm -e wine
fi
if [ -f /etc/debian_version ]
then
    DISTRO="Debian"
    apt-get remove wine
fi
if [ `grep Ubuntu /etc/lsb-release` ]
then
    DISTRO="Ubuntu"
    apt-get remove wine
fi
echo "Если вы используете $DISTRO, значит мы правильно определили ваш дистрибутив."
echo
sleep 5

###

echo "Сейчас мы узнаем какая версия wine последняя..."
wget http://ibiblio.org/pub/linux/system/emulators/wine/wine.lsm -O $TEMP/wineversion -o /tmp/tokill
WINEVERSION=`grep Version $TEMP/wineversion | awk '{print $2;}'`
echo "Это версия $WINEVERSION. Скачаем и распакуем ее..."
sleep 5

###

cp wot-patch $TEMP
wget -c --passive http://ibiblio.org/pub/linux/system/emulators/wine/wine-$WINEVERSION.tar.bz2 -O $TEMP/wine-$WINEVERSION.tar.bz2
PWD=`pwd`
cd $TEMP
tar xvfj wine-$WINEVERSION.tar.bz2
cd wine-$WINEVERSION
patch -p1 < $TEMP/wot-patch
echo
echo "Пропатчено!"
echo "Теперь мы скомпилируем и установим wine"
echo
sleep 5
./configure --with-openal --prefix=$WINEPREFIX
make
make install
cd $PWD
echo
sleep 5

###

echo "Wine установлен. Еще раз проверим версию..."
REALWINEVERSION=`wine --version`
if [ "$REALWINEVERSION" = "wine-$WINEVERSION" ]
then
    echo "Да, все установлено правильно."
else
    echo "Плохо, версии не совпадают. Возможно неправильный префикс?"
    echo "Мы использовали $WINEPREFIX."
    echo "Выходим..."
    exit 1
fi
echo
sleep 5

###

echo "Ok, теперь мы можем скачать самую свежую версию winetricks и установить несколько необходимых библиотек."
wget http://www.kegel.com/wine/winetricks -O $TEMP/winetricks -o /tmp/tokill
chmod +x $TEMP/winetricks
$TEMP/winetricks d3dx9_36 vcrun2008 corefonts msxml3 wininet ie7
echo
sleep 5

###

echo "Ok, мы все сделали."
echo "Теперь вы можете скачать и установить WoT по этой ссылке http://game.worldoftanks.ru/update"
echo "После установки клиента игры, попробуйте запустить лаунчер через терминал такой командой: env WINE_CURSOR=X LANG=ru_RU.UTF8 wine WOTLauncher.exe"
echo "Если лаунчер не работает, то запускайте игру напрямую: env WINE_CURSOR=X LANG=ru_RU.UTF8 wine WorldOfTanks.exe"  
echo "Для корректной работы курсора, запускайте игру в полноэкранном режиме и с соотношением сторон 4:3"
echo "Удачных боев!"
echo
exit 0
